﻿import es
import gamethread
import cfglib
import usermsg
import playerlib
import langlib
import effectlib



config = cfglib.AddonCFG(es.getAddonPath("anticamp") + "/settings.cfg")
config.text("**************************")
config.text("    Addon Settings    ")
config.text("**************************")
camptime = config.cvar("camptime",   10, "You can set the Time when a Player is camping")
punish = config.cvar("punish",   1, "With 1 you can slap the player, 2 = Beacon , 3 = Strip weapons , 4 = Blind Player")
lost = config.cvar("lost",   10, "How much Hp should the camper lose by slapping")
bombcampallow = config.cvar("bombcampallow",   1, "1 = Disalbe anticamp when bomb is planted, 0 = Disable")
config.write()


anticamp = {}
slaplist = set()
beaconlist = set()
blindlist = set()
striplist = set()


def load():
	config.execute()
	global text
	download()
	text = langlib.Strings(es.getAddonPath("anticamp") + "/strings.ini")
	for userid in es.getUseridList():
		disableAutokick(userid)

def player_activate(ev):
	disableAutokick(ev['userid'])

def disableAutokick(userid):
	es.server.mp_disable_autokick(userid)
      

def es_map_start():
	download()

def round_start(ev):
	ac_loop()

def round_end(ev):
	gamethread.cancelDelayed("acloop")


def ac_loop():
	gamethread.delayedname(1, 'acloop', ac_loop)
	for userid in es.getUseridList():
		if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
			if es.getplayerteam(userid) in (2,3):
				location = es.getplayerlocation(userid)
				if not anticamp.has_key(userid):
					anticamp[userid] = {}
					anticamp[userid]['count'] = 0
					anticamp[userid]['location'] = location
				if location == anticamp[userid]['location']:
					anticamp[userid]['count'] += 1
					if anticamp[userid]['count'] >= camptime:       
						if punish == 1:
							slaplist.add(userid)
							slap(userid)
							es.tell(userid , '#multi', text("slap", {}, playerlib.getPlayer(userid).get('lang')))
						elif punish == 2:
							beaconlist.add(userid)
							beacon(userid)
							es.tell(userid, '#multi', text("beacon", {}, playerlib.getPlayer(userid).get('lang')))
						elif punish == 3:
							striplist.add(userid)
							strip(userid)
							es.tell(userid, '#multi', text("strip", {}, playerlib.getPlayer(userid).get('lang')))
						elif punish == 4:
							blindlist.add(userid)
							blind(userid)
							es.tell(userid, '#multi', text("blind", {}, playerlib.getPlayer(userid).get('lang')))
				else:
					anticamp[userid]['count'] = 0
					anticamp[userid]['location'] = location
					if punish == 1:
						slaplist.discard(userid)
					elif punish == 2:
						beaconlist.discard(userid)
					elif punish == 3:
						striplist.discard(userid)
					elif punish == 4:
						blindlist.discard(userid)

def beacon(userid):
	if userid in beaconlist:
		es.emitsound("player", userid, "anticamp/beacon.wav", 1.0, 0.7)
		if es.getplayerteam(userid) == 3:
			r = 0
			b = 255
		else:
			r = 255
			b = 0
		x,y,z = es.getplayerlocation(userid)
		effectlib.drawCircle((x,y,z + 10),radius=100,steps=12,halo="sprites/lgtning.vmt",model="sprites/lgtning.vmt",seconds=0.7,width=10,endwidth=10,red=r,green=50,blue=b)


              
def slap(userid):
	if userid in slaplist:
		if es.getplayerprop(userid, 'CBasePlayer.m_iHealth') >= int(lost):
			es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth') - int(lost))
		else:
			es.server.insertcmd('es_xsexec %s "kill"' % userid)
def blind(userid):
	if userid in blindlist:
		usermsg.fade(userid, 1, 2, 1000, 2, 2, 2, 255)


def bomb_planted(ev):
	if bombcampallow == 1:
		gamethread.cancelDelayed("acloop")
		es.msg('#multi', text("bomb", {}, playerlib.getPlayer(ev['userid']).get('lang')))


def strip(userid):
	if userid in striplist:
		es.server.queuecmd('es_xfire %s player_weaponstrip kill' % userid)
		es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
		es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
       
def unload():
	gamethread.cancelDelayed("acloop")

def download():
	es.stringtable('downloadables', 'sound/anticamp/beacon.wav')